/**
 * @license
 * Copyright 2018 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import { Tensor } from '../tensor';
import { Rank } from '../types';
import { DataType, ShapeMap } from '../types';
import { KernelBackend } from './backend';
export * from '../ops/axis_util';
export * from '../ops/broadcast_util';
export * from '../ops/concat_util';
export * from '../ops/conv_util';
export { Activation, FusedConv2DConfig } from '../ops/fused_util';
export * from '../ops/reduce_util';
export { BackendValues, TypedArray, upcastType, PixelData } from '../types';
export { MemoryInfo, TimingInfo } from '../engine';
export declare function castTensor<T extends Tensor>(x: T, dtype: DataType, backend: KernelBackend): T;
export declare function reshapeTensor<T extends Tensor, R extends Rank>(x: T, shape: ShapeMap[R]): Tensor<R>;
export declare function linspaceImpl(start: number, stop: number, num: number): Tensor<Rank.R1>;
